/* lsystem1 -- really basic Lindenmayer system-grapher in wxwindows.  Set
	up for RTmix, but no sound in this one -- BGG 2/2003
*/

#include "wx/wxprec.h"

#ifndef WX_PRECOMP
	#include "wx/wx.h"
#endif

#include "lsystem1.h"
#include <iostream.h>

#define MAIN		/* So RTcmix globals will be right */
#include <globals.h>
#include <RTcmix.h>


IMPLEMENT_APP(lsystem1)

bool lsystem1::OnInit()
{
	wxFrame *frame = new wxFrame((wxFrame*) NULL, -1, "lsystem1",
		wxPoint(50, 50), wxSize(1000, 600),
		wxDEFAULT_FRAME_STYLE, "lsystem1");
	frame->Show(TRUE);
	SetTopWindow(frame);

	wxButton *button = new wxButton(frame, BUTTON_HIT, "realize!",
		wxPoint(100, 550), wxSize(70, 20));

	wdc = new wxClientDC(frame);
	recurse_levels = 7;

	return true;
}

void lsystem1::OnButton(wxCommandEvent& command)
{
	// this function starts the first line, and then calls
	// "recurse", which does, in fact, recurse.
	int x, y, length;

	x = 0;
	y = 250;
	length = 1000/4;

	wdc->SetPen(*wxRED_PEN);
	wdc->DrawLine(x,y, length,y);

	recurse(x+length, y, length/2, recurse_levels-1);
}

void lsystem1::recurse(int x, int y, int length, int rlevel)
{
	if (rlevel == 0) return;

	// draw the lines, the l-system is done by altering the length x,y's
	wdc->SetPen(*wxRED_PEN);
	wdc->DrawLine(x,y, x+length,y-20);
	wdc->DrawLine(x,y, x+length,y+5);

	// do both branches
	recurse(x+length, y-20, length-10, rlevel-1);
	recurse(x+length, y+5, length-25, rlevel-1);
}


BEGIN_EVENT_TABLE(lsystem1, wxApp)
	EVT_BUTTON(BUTTON_HIT, lsystem1::OnButton)
END_EVENT_TABLE()

